package apirequest

import (
	"fmt"
	"github.com/myzhan/boomer"
	"io"
	"io/ioutil"
	"strings"
	"time"
)

func GetApi(path, url string) {
	start := time.Now()
	// HttpSSLProxyHeader 本目录
	resp, err := HttpSSLProxyHeader(path, url)
	elapsed := time.Since(start)

	if err != nil {
		boomer.RecordFailure("https", url, elapsed.Nanoseconds()/int64(time.Millisecond), err.Error())
	}
	if resp != nil && strings.Contains(resp.Status, "200") {
		boomer.RecordSuccess("https", url, elapsed.Nanoseconds()/int64(time.Millisecond), int64(10))
		// 输出返回值
		body, errBody := ioutil.ReadAll(resp.Body)
		if errBody != nil {
			fmt.Println("errBody: ", errBody)
		} else if body != nil {
			fmt.Println("resp body:", string(body))
		}
	}

	// 关闭连接
	if resp != nil {
		defer func(Body io.ReadCloser) {
			err := Body.Close()
			if err != nil {

			}
		}(resp.Body)
	}


}
